Index: /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/callkeys.h	(revision 1216)
@@ -3,43 +3,40 @@
 ! symbols '&' in columns 73 and 6
 !
-      COMMON/callkeys/callrad,corrk,calldifv,UseTurbDiff,calladj        &
+! Group commons according to their type for minimal performance impact
+
+      COMMON/callkeys_l/callrad,corrk,calldifv,UseTurbDiff,calladj      &
      &   , co2cond,callsoil                                             &
-     &   , season,diurnal,tlocked,rings_shadow,iradia,lwrite            &
-     &   , iaervar,iddist,topdustref,callstats,calleofdump              &
+     &   , season,diurnal,tlocked,rings_shadow,lwrite                   &
+     &   , callstats,calleofdump                                        &
      &   , enertest                                                     &
      &   , callgasvis,continuum,H2Ocont_simple,graybody                 &
-     &   , Nmix_co2, radfixed, dusttau                                  &
+     &   , radfixed                                                     &
      &   , meanOLR, specOLR                                             &
-     &   , kastprof, Tstrat                                             &
-     &   , nosurf, intheat, flatten, oblate                             &     
-     &   , newtonian, tau_relax, testradtimes                           &
+     &   , kastprof                                                     &
+     &   , nosurf, oblate                                               &     
+     &   , newtonian, testradtimes                                      &
      &   , check_cpp_match, force_cpp                                   &
      &   , rayleigh                                                     &
-     &   , stelbbody, stelTbb                                           &
-     &   , tplanet                                                      &
-     &   , obs_tau_col_tropo                                            &
-     &   , obs_tau_col_strato                                           &
-     &   , pres_bottom_tropo                                            &
-     &   , pres_top_tropo                                               &
-     &   , pres_bottom_strato                                           &
-     &   , pres_top_strato                                              &
-     &   , size_tropo                                                   &
-     &   , size_strato                                                  &
-     &   , startype, Fat1AU                                             &
+     &   , stelbbody                                                    &
      &   , nearco2cond                                                  &
-     &   , tracer, mass_redistrib, varactive, varfixed, satval          &
+     &   , tracer, mass_redistrib, varactive, varfixed                  &
      &   , sedimentation,water,watercond,waterrain                      &
      &   , aeroco2,aeroh2o,aeroh2so4,aeroback2lay                       &
      &   , aerofixco2,aerofixh2o                                        &
-     &   , hydrology, sourceevol, icetstep, albedosnow                  &
-     &   , maxicethick, Tsaldiff                                        &
-     &   , CLFfixval, CLFvarying                                        &
-     &   , n2mixratio                                                   &
-     &   , co2supsat                                                    &
-     &   , cloudlvl                                                     &
-     &   , pceil                                                        &
-     &   , Rmean, J2, MassPlanet                                        &
+     &   , hydrology, sourceevol                                        &
+     &   , CLFvarying                                                   &
      &   , strictboundcorrk                                                                                     
 
+      COMMON/callkeys_i/iaervar,iddist,iradia,startype
+      
+      COMMON/callkeys_r/topdustref,Nmix_co2,dusttau,Fat1AU,stelTbb,     &
+     &                  Tstrat,tplanet,obs_tau_col_tropo,               &
+     &                  obs_tau_col_strato,pres_bottom_tropo,           &
+     &                  pres_top_tropo,pres_bottom_strato,              &
+     &                  pres_top_strato,size_tropo,size_strato,satval,  &
+     &                  CLFfixval,n2mixratio,co2supsat,pceil,albedosnow,&
+     &                  maxicethick,Tsaldiff,tau_relax,cloudlvl,        &
+     &                  icetstep,intheat,flatten,Rmean,J2,MassPlanet
+      
       logical callrad,corrk,calldifv,UseTurbDiff                        &
      &   , calladj,co2cond,callsoil                                     &
Index: /trunk/LMDZ.GENERIC/libf/phystd/comgeomphy.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/comgeomphy.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/phystd/comgeomphy.F90	(revision 1216)
@@ -0,0 +1,23 @@
+module comgeomphy
+   real,save,allocatable :: airephy(:)
+   real,save,allocatable :: cuphy(:)
+   real,save,allocatable :: cvphy(:)
+   real,save,allocatable :: rlatd(:)
+   real,save,allocatable :: rlond(:)
+!$OMP THREADPRIVATE(airephy,cuphy,cvphy,rlatd,rlond)
+contains
+  
+  subroutine initcomgeomphy
+  USE mod_phys_lmdz_para, only: klon_omp
+  implicit none
+    
+ 
+    allocate(airephy(klon_omp))
+    allocate(cuphy(klon_omp))
+    allocate(cvphy(klon_omp))
+    allocate(rlatd(klon_omp))
+    allocate(rlond(klon_omp))
+
+  end subroutine initcomgeomphy
+  
+end module comgeomphy
Index: /trunk/LMDZ.GENERIC/libf/phystd/comsoil_h.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/comsoil_h.F90	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/comsoil_h.F90	(revision 1216)
@@ -1,12 +1,31 @@
+module comsoil_h
 
-       module comsoil_h
+implicit none
+! nsoilmx : number of subterranean layers
+!integer, parameter :: nsoilmx = 18 ! for z1=0.0002 m, depth = 18 m => mars case 
+!integer, parameter :: nsoilmx = 13 ! for z1=0.03 m, depth = 104.8 m => earth case
+  integer, parameter :: nsoilmx = 18 
 
-       implicit none
+  real,save,allocatable,dimension(:) :: layer      ! soil layer depths
+  real,save,allocatable,dimension(:) :: mlayer     ! soil mid-layer depths
+  real,save,allocatable,dimension(:,:) :: inertiedat ! soil thermal inertia
+  real,save :: volcapa    ! soil volumetric heat capacity
+       ! NB: volcapa is read fromn control(35) from physicq start file
+       !     in physdem (or set via tabfi, or initialized in
+       !                 soil_settings.F)
 
-       real,allocatable,dimension(:) :: layer      ! soil layer depths
-       real,allocatable,dimension(:) :: mlayer     ! soil mid-layer depths
-       real,allocatable,dimension(:,:) :: inertiedat ! soil thermal inertia
-       real volcapa    ! soil volumetric heat capacitya
+contains
 
-       end module comsoil_h
+  subroutine ini_comsoil_h(ngrid)
+  
+  implicit none
+  integer,intent(in) :: ngrid ! number of atmospheric columns
+  
+    if (.not.allocated(layer)) allocate(layer(nsoilmx)) !soil layer depths
+    if (.not.allocated(mlayer)) allocate(mlayer(0:nsoilmx-1)) ! soil mid-layer depths
+    if (.not.allocated(inertiedat)) allocate(inertiedat(ngrid,nsoilmx)) ! soil thermal inertia
+  
+  end subroutine ini_comsoil_h
 
+end module comsoil_h
+
Index: /trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/condense_cloud.F90	(revision 1216)
@@ -7,10 +7,10 @@
 
       use radinc_h, only : naerkind
-      use gases_h
+      use gases_h, only: gfrac, igas_co2
       use radii_mod, only : co2_reffrad
       use aerosol_mod, only : iaero_co2
-      USE surfdat_h
-      USE comgeomfi_h
-      USE tracer_h
+      USE surfdat_h, only: albedodat, albedice, emisice, emissiv
+      USE comgeomfi_h, only: lati
+      USE tracer_h, only: noms, rho_co2
 
 
@@ -453,8 +453,8 @@
 !     --------------------------------------------------------------------
       DO ig=1,ngrid
-         IF(ig.GT.ngrid/2+1) THEN
-            icap=2
+         IF(lati(ig).LT.0.) THEN
+            icap=2 ! Southern Hemisphere
          ELSE
-            icap=1
+            icap=1 ! Nortnern hemisphere
          ENDIF
 
Index: /trunk/LMDZ.GENERIC/libf/phystd/dimphy.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/dimphy.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/phystd/dimphy.F90	(revision 1216)
@@ -0,0 +1,32 @@
+MODULE dimphy
+  
+  INTEGER,SAVE :: klon   ! number of atmospheric columns (for this OpenMP subgrid)
+  INTEGER,SAVE :: klev   ! number of atmospheric layers
+  INTEGER,SAVE :: klevp1 ! number of atmospheric layers+1
+  INTEGER,SAVE :: klevm1 ! number of atmospheric layers-1
+!  INTEGER,SAVE :: kflev
+
+!$OMP THREADPRIVATE(klon)
+
+CONTAINS
+  
+  SUBROUTINE Init_dimphy(klon0,klev0)
+  IMPLICIT NONE
+  
+    INTEGER, INTENT(in) :: klon0
+    INTEGER, INTENT(in) :: klev0
+    
+    klon=klon0
+    
+!$OMP MASTER 
+    klev=klev0
+    klevp1=klev+1
+    klevm1=klev-1
+!    kflev=klev
+!$OMP END MASTER    
+!$OMP BARRIER
+    
+  END SUBROUTINE Init_dimphy
+
+  
+END MODULE dimphy
Index: /trunk/LMDZ.GENERIC/libf/phystd/dimphys.h
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/dimphys.h	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/dimphys.h	(revision 1216)
@@ -7,7 +7,7 @@
 ! nlayermx : number of atmospheric layers
       integer, parameter :: nlayermx = llm 
-! nsoilmx : number of subterranean layers
+! nsoilmx : number of subterranean layers ! nsoilmx is now in comsoil_h
       !integer, parameter :: nsoilmx = 4 ! for a test 
-      integer, parameter :: nsoilmx = 18 ! for z1=0.0002 m, depth = 18 m => mars case 
+      !integer, parameter :: nsoilmx = 18 ! for z1=0.0002 m, depth = 18 m => mars case 
       !integer, parameter :: nsoilmx = 13 ! for z1=0.03 m, depth = 104.8 m => earth case
 !-----------------------------------------------------------------------
Index: /trunk/LMDZ.GENERIC/libf/phystd/ini_archive.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/ini_archive.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/ini_archive.F	(revision 1216)
@@ -36,5 +36,5 @@
 
       USE comsoil_h
- 
+!      use control_mod
       implicit none
 
@@ -49,5 +49,5 @@
 #include "logic.h"
 #include "serre.h"
-#include "control.h"
+!#include "control.h"
 
 #include "netcdf.inc"
Index: /trunk/LMDZ.GENERIC/libf/phystd/inifis.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/inifis.F	(revision 1216)
@@ -1,3 +1,3 @@
-      SUBROUTINE inifis(ngrid,nlayer,
+      SUBROUTINE inifis(ngrid,nlayer,nq,
      $           day_ini,pdaysec,ptimestep,
      $           plat,plon,parea,
@@ -6,11 +6,8 @@
       use radinc_h, only : naerkind
       use datafile_mod, only: datadir
-      use comdiurn_h
-
-      !! to be conservative, but why this include here?
-      use surfdat_h
-      use comsaison_h
-
-      USE comgeomfi_h
+      use comdiurn_h, only: sinlat, coslat, sinlon, coslon
+      use comgeomfi_h, only: long, lati, area, totarea
+      use comsoil_h, only: ini_comsoil_h
+      use control_mod, only: ecritphy
 
 !=======================================================================
@@ -61,8 +58,8 @@
 
 
-      REAL prad,pg,pr,pcpp,pdaysec,ptimestep
+      REAL,INTENT(IN) :: prad,pg,pr,pcpp,pdaysec,ptimestep
  
-      INTEGER ngrid,nlayer
-      REAL plat(ngrid),plon(ngrid),parea(ngrid)
+      INTEGER,INTENT(IN) :: ngrid,nlayer,nq
+      REAL,INTENT(IN) :: plat(ngrid),plon(ngrid),parea(ngrid)
       integer day_ini
       INTEGER ig,ierr
@@ -102,4 +99,8 @@
          STOP
       ENDIF
+
+      ! read in 'ecritphy' (frequency of calls to physics, in dynamical steps)
+      ! (also done in dyn3d/defrun_new but not in LMDZ.COMMON)
+      call getin("ecritphy",ecritphy)
 
 ! --------------------------------------------------------------
@@ -691,7 +692,9 @@
          coslon(ig)=cos(plon(ig))
       ENDDO
-     	 
+
       pi=2.*asin(1.) ! NB: pi is a common in comcstfi.h
 
-      RETURN
+      ! allocate "comsoil_h" arrays
+      call ini_comsoil_h(ngrid)
+      
       END
Index: /trunk/LMDZ.GENERIC/libf/phystd/iniphysiq.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/iniphysiq.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/phystd/iniphysiq.F90	(revision 1216)
@@ -0,0 +1,77 @@
+subroutine iniphysiq(ngrid,nlayer, punjours, pdayref,ptimestep,          &
+                     plat,plon,parea,pcu,pcv,                            &
+                     prad,pg,pr,pcpp,iflag_phys)
+
+use dimphy, only : klev ! number of atmospheric levels
+use mod_grid_phy_lmdz, only : klon_glo ! number of atmospheric columns
+                                       ! (on full grid)
+use mod_phys_lmdz_para, only : klon_omp, & ! number of columns (on local omp grid)
+                               klon_omp_begin, & ! start index of local omp subgrid
+                               klon_omp_end, & ! end index of local omp subgrid
+                               klon_mpi_begin ! start indes of columns (on local mpi grid)
+use comgeomphy, only : airephy, & ! physics grid area (m2)
+                       cuphy, & ! cu coeff. (u_covariant = cu * u)
+                       cvphy, & ! cv coeff. (v_covariant = cv * v)
+                       rlond, & ! longitudes
+                       rlatd ! latitudes
+use infotrac, only : nqtot ! number of advected tracers
+
+implicit none
+
+real,intent(in) :: prad ! radius of the planet (m)
+real,intent(in) :: pg ! gravitational acceleration (m/s2)
+real,intent(in) :: pr ! ! reduced gas constant R/mu
+real,intent(in) :: pcpp ! specific heat Cp
+real,intent(in) :: punjours ! length (in s) of a standard day
+integer,intent(in) :: ngrid ! number of horizontal grid points in the physics (full grid)
+integer,intent(in) :: nlayer ! number of atmospheric layers
+real,intent(in) :: plat(ngrid) ! latitudes of the physics grid
+real,intent(in) :: plon(ngrid) ! longitudes of the physics grid
+real,intent(in) :: parea(klon_glo) ! area (m2)
+real,intent(in) :: pcu(klon_glo) ! cu coeff. (u_covariant = cu * u)
+real,intent(in) :: pcv(klon_glo) ! cv coeff. (v_covariant = cv * v)
+integer,intent(in) :: pdayref ! reference day of for the simulation
+real,intent(in) :: ptimestep !physics time step (s)
+integer,intent(in) :: iflag_phys ! type of physics to be called
+
+integer :: ibegin,iend,offset
+character(len=20) :: modname='iniphysiq'
+character(len=80) :: abort_message
+
+IF (nlayer.NE.klev) THEN
+  write(*,*) 'STOP in ',trim(modname)
+  write(*,*) 'Problem with dimensions :'
+  write(*,*) 'nlayer     = ',nlayer
+  write(*,*) 'klev   = ',klev
+  abort_message = ''
+  CALL abort_gcm (modname,abort_message,1)
+ENDIF
+
+IF (ngrid.NE.klon_glo) THEN
+  write(*,*) 'STOP in ',trim(modname)
+  write(*,*) 'Problem with dimensions :'
+  write(*,*) 'ngrid     = ',ngrid
+  write(*,*) 'klon   = ',klon_glo
+  abort_message = ''
+  CALL abort_gcm (modname,abort_message,1)
+ENDIF
+
+!$OMP PARALLEL PRIVATE(ibegin,iend) 
+!$OMP+         SHARED(parea,pcu,pcv,plon,plat)
+      
+offset=klon_mpi_begin-1
+airephy(1:klon_omp)=parea(offset+klon_omp_begin:offset+klon_omp_end)
+cuphy(1:klon_omp)=pcu(offset+klon_omp_begin:offset+klon_omp_end)
+cvphy(1:klon_omp)=pcv(offset+klon_omp_begin:offset+klon_omp_end)
+rlond(1:klon_omp)=plon(offset+klon_omp_begin:offset+klon_omp_end)
+rlatd(1:klon_omp)=plat(offset+klon_omp_begin:offset+klon_omp_end)
+
+! copy some fundamental parameters to physics 
+! and do some initializations 
+call inifis(klon_omp,nlayer,nqtot,pdayref,punjours,ptimestep, &
+            rlatd,rlond,airephy,prad,pg,pr,pcpp)
+
+!$OMP END PARALLEL
+
+
+end subroutine iniphysiq
Index: /trunk/LMDZ.GENERIC/libf/phystd/inistats.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/inistats.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/inistats.F	(revision 1216)
@@ -1,7 +1,5 @@
       subroutine inistats(ierr)
 
-#ifdef CPP_PARA
       use mod_phys_lmdz_para, only : is_master
-#endif
       implicit none
 
@@ -14,7 +12,4 @@
 #include "netcdf.inc"
 
-#ifndef CPP_PARA
-      logical,parameter :: is_master=.true.
-#endif
       integer,intent(out) :: ierr
       integer :: nid
@@ -32,14 +27,9 @@
       nsteppd=nint(daysec/dtphys)
       write (*,*) 'nsteppd=',nsteppd
-      write (*,*) 'istime=',istime
-
-
-
       if (abs(float(nsteppd)-daysec/dtphys).gt.1.e-8*daysec)
-     ,   stop'Dans Instat:  1jour .ne. n pas physiques'
-
+     &   stop'Dans Instat:  1jour .ne. n pas physiques'
 
       if(mod(nsteppd,istime).ne.0)
-     ,   stop'Dans Instat:  1jour .ne. n*istime pas physiques'
+     &   stop'Dans Instat:  1jour .ne. n*istime pas physiques'
 
       istats=nsteppd/istime
@@ -57,5 +47,5 @@
       ! only the master needs do this
 
-      ierr = NF_CREATE("stats.nc",NF_CLOBBER,nid)
+      ierr = NF_CREATE("stats.nc",IOR(NF_CLOBBER,NF_64BIT_OFFSET),nid)
       if (ierr.ne.NF_NOERR) then
          write (*,*) NF_STRERROR(ierr)
@@ -70,11 +60,11 @@
 
       ierr = NF_ENDDEF(nid)
-      call def_var(nid,"Time","Time",
-     .            "days since 0000-00-0 00:00:00",1,
-     .            idim_time,nvarid,ierr)
+      call def_var_stats(nid,"Time","Time",
+     &            "days since 0000-00-0 00:00:00",1,
+     &            idim_time,nvarid,ierr)
 ! Time is initialised later by mkstats subroutine
 
-      call def_var(nid,"latitude","latitude","degrees_north",1,
-     .            idim_lat,nvarid,ierr)
+      call def_var_stats(nid,"latitude","latitude",
+     &            "degrees_north",1,idim_lat,nvarid,ierr)
 #ifdef NC_DOUBLE
       ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlatu/pi*180)
@@ -82,6 +72,6 @@
       ierr = NF_PUT_VAR_REAL (nid,nvarid,rlatu/pi*180)
 #endif
-      call def_var(nid,"longitude","East longitude","degrees_east",1,
-     .            idim_lon,nvarid,ierr)
+      call def_var_stats(nid,"longitude","East longitude",
+     &            "degrees_east",1,idim_lon,nvarid,ierr)
 #ifdef NC_DOUBLE
       ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,rlonv/pi*180)
@@ -106,6 +96,6 @@
       ierr = NF_PUT_VAR_REAL (nid,nvarid,pseudoalt)
 #endif 
-      call def_var(nid,"aps","hybrid pressure at midlayers"," ",
-     .            1,idim_llm,nvarid,ierr)
+      call def_var_stats(nid,"aps","hybrid pressure at midlayers"
+     & ," ",1,idim_llm,nvarid,ierr)
 #ifdef NC_DOUBLE
       ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,aps)
@@ -114,6 +104,6 @@
 #endif
 
-      call def_var(nid,"bps","hybrid sigma at midlayers"," ",
-     .            1,idim_llm,nvarid,ierr)
+      call def_var_stats(nid,"bps","hybrid sigma at midlayers"
+     & ," ",1,idim_llm,nvarid,ierr)
 #ifdef NC_DOUBLE
       ierr = NF_PUT_VAR_DOUBLE (nid,nvarid,bps)
@@ -125,3 +115,4 @@
 
       endif ! of if (is_master)
-      end
+      end subroutine inistats
+
Index: /trunk/LMDZ.GENERIC/libf/phystd/init_phys_lmdz.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/init_phys_lmdz.F90	(revision 1216)
+++ /trunk/LMDZ.GENERIC/libf/phystd/init_phys_lmdz.F90	(revision 1216)
@@ -0,0 +1,27 @@
+!
+! $Id$
+!
+SUBROUTINE init_phys_lmdz(iim,jjp1,llm,nb_proc,distrib)
+  USE mod_phys_lmdz_omp_data, only: klon_omp
+  USE mod_grid_phy_lmdz, only: nbp_lev
+  USE mod_phys_lmdz_para, only: init_phys_lmdz_para
+  USE mod_grid_phy_lmdz, only: init_grid_phy_lmdz
+  USE dimphy, ONLY : init_dimphy
+
+  IMPLICIT NONE
+  
+    INTEGER,INTENT(in) :: iim
+    INTEGER,INTENT(in) :: jjp1
+    INTEGER,INTENT(in) :: llm
+    INTEGER,INTENT(in) :: nb_proc
+    INTEGER,INTENT(in) :: distrib(0:nb_proc-1)
+
+
+    CALL init_grid_phy_lmdz(iim,jjp1,llm)
+    CALL init_phys_lmdz_para(iim,jjp1,nb_proc,distrib)
+!$OMP PARALLEL
+    CALL init_dimphy(klon_omp,nbp_lev)
+
+!$OMP END PARALLEL
+ 
+END SUBROUTINE init_phys_lmdz  
Index: /trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/iniwrite.F	(revision 1216)
@@ -1,6 +1,5 @@
       SUBROUTINE iniwrite(nid,idayref,phis)
 
-      USE comsoil_h
-
+      use comsoil_h, only: mlayer, nsoilmx
       IMPLICIT NONE
 
@@ -23,21 +22,18 @@
 #include "dimensions.h"
 #include "paramet.h"
-!include "comconst.h"
 #include "comcstfi.h"
 #include "comvert.h"
 #include "comgeom.h"
-#include "temps.h"
 #include "ener.h"
 #include "logic.h"
 #include "netcdf.inc"
 #include "serre.h"
-#include"dimphys.h"
 
 c   Arguments:
 c   ----------
 
-      integer nid        ! NetCDF file ID
-      INTEGER*4 idayref  ! date (initial date for this run)
-      REAL phis(ip1jmp1) ! surface geopotential
+      integer,intent(in) :: nid        ! NetCDF file ID
+      INTEGER*4,intent(in) :: idayref  ! date (initial date for this run)
+      real,intent(in) :: phis(ip1jmp1) ! surface geopotential
 
 c   Local:
@@ -57,8 +53,8 @@
          tab_cntrl(l)=0.
       ENDDO
-      tab_cntrl(1)  = FLOAT(iim)
-      tab_cntrl(2)  = FLOAT(jjm)
-      tab_cntrl(3)  = FLOAT(llm)
-      tab_cntrl(4)  = FLOAT(idayref)
+      tab_cntrl(1)  = real(iim)
+      tab_cntrl(2)  = real(jjm)
+      tab_cntrl(3)  = real(llm)
+      tab_cntrl(4)  = real(idayref)
       tab_cntrl(5)  = rad
       tab_cntrl(6)  = omeg
@@ -252,5 +248,5 @@
 
 !-------------------------------
-! (soil) depth variable mlayer() (known from comsoil.h)
+! (soil) depth variable mlayer() (known from comsoil_h)
 !-------------------------------
       ierr=NF_REDEF (nid) ! Enter NetCDF (re-)define mode
Index: /trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90	(revision 1215)
+++ /trunk/LMDZ.GENERIC/libf/phystd/iniwritesoil.F90	(revision 1216)
@@ -1,9 +1,3 @@
 subroutine iniwritesoil(nid,ngrid)
-
-use comsoil_h, only : inertiedat, mlayer
-#ifdef CPP_PARA
-use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
-use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
-#endif
 
 ! initialization routine for 'writediagoil'. Here we create/define
@@ -11,8 +5,9 @@
 ! (time-independent) parameters.
 
+use comsoil_h, only: mlayer, inertiedat, nsoilmx
+
 implicit none
 
 #include"dimensions.h"
-#include"dimphys.h"
 #include"paramet.h"
 #include"comcstfi.h"
@@ -38,15 +33,5 @@
 integer :: i,j,l,ig0
 
-#ifdef CPP_PARA
-! Added to work in parallel mode
-real dx3_glop(klon_glo,nsoilmx)
-real dx3_glo(iim,jjp1,nsoilmx) ! to store a global 3D data set
-#else
-logical,parameter :: is_master=.true.
-logical,parameter :: is_mpi_root=.true.
-#endif
-
 ! 1. Define the dimensions
-if (is_master) then
 ! Switch to NetCDF define mode
 ierr=NF_REDEF(nid)
@@ -170,5 +155,5 @@
 ierr=NF_PUT_VAR_REAL(nid,varid,mlayer)
 #endif
-! Note mlayer(0:nsoilmx-1) known from comsoil.h
+! Note mlayer(0:nsoilmx-1) known from comsoil_h
 if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not write depth variable"
@@ -197,10 +182,7 @@
 ! Note no need to write time variable here; it is done in writediagsoil.
 
-endif ! of if (is_master) 
-
 ! 3. Other variables to be included
 
 ! 3.1 mesh area surrounding each horizontal point
-if (is_master) then
 ierr=NF_REDEF(nid) ! switch to NetCDF define mode
 
@@ -236,9 +218,5 @@
 endif
 
-endif ! of if (is_master)
-
-
 ! 3.2 Thermal inertia
-if (is_master) then
 ierr=NF_REDEF(nid) ! switch to NetCDF define mode
 
@@ -262,21 +240,7 @@
 ierr=NF_PUT_ATT_TEXT(nid,varid,"units",len_trim(text),text)
 
-endif !of if (is_master)
-
 ! Recast data along 'dynamics' grid
-#ifdef CPP_PARA
-  ! gather field on a "global" (without redundant longitude) array
-  call Gather(inertiedat,dx3_glop)
-!$OMP MASTER
-  if (is_mpi_root) then
-    call Grid1Dto2D_glo(dx3_glop,dx3_glo)
-    ! copy dx3_glo() to dx3(:) and add redundant longitude
-    data3(1:iim,:,:)=dx3_glo(1:iim,:,:)
-    data3(iip1,:,:)=data3(1,:,:)
-  endif
-!$OMP END MASTER
-!$OMP BARRIER
-#else
-! Note: inertiedat is known from comsoil.h
+! Note: inertiedat is known from comsoil_h
+
 do l=1,nsoilmx
   ! handle the poles
@@ -294,19 +258,16 @@
   enddo
 enddo ! of do l=1,nsoilmx
-#endif
-
-! Write data3 to file
-if (is_master) then
- ierr=NF_ENDDEF(nid) ! switch out of NetCDF define mode
- ! Write
-#ifdef NC_DOUBLE
- ierr=NF_PUT_VAR_DOUBLE(nid,varid,data3)
-#else
- ierr=NF_PUT_VAR_REAL(nid,varid,data3)
-#endif
- if (ierr.ne.NF_NOERR) then
+
+! Write data2 to file
+ierr=NF_ENDDEF(nid) ! switch out of NetCDF define mode
+! Write
+#ifdef NC_DOUBLE
+ierr=NF_PUT_VAR_DOUBLE(nid,varid,data3)
+#else
+ierr=NF_PUT_VAR_REAL(nid,varid,data3)
+#endif
+if (ierr.ne.NF_NOERR) then
   write(*,*)"iniwritesoil: Error, could not write th_inertia variable"
- endif
-endif ! of if (is_master)
+endif
 
 end subroutine iniwritesoil
